"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LeafletDrawProvider = void 0;
var leaflet_1 = __importDefault(require("leaflet"));
require("leaflet-draw");
var react_1 = __importStar(require("react"));
var react_leaflet_1 = require("react-leaflet");
var context_1 = require("./context");
var LeafletDrawProvider = function (props) {
    var map = react_leaflet_1.useMap();
    var polygonHandler = react_1.useState(new leaflet_1.default.Draw.Polygon(map))[0];
    var polylineHandler = react_1.useState(new leaflet_1.default.Draw.Polyline(map))[0];
    var rectangleHandler = react_1.useState(new leaflet_1.default.Draw.Rectangle(map))[0];
    var markerHandler = react_1.useState(new leaflet_1.default.Draw.Marker(map))[0];
    var circleHandler = react_1.useState(new leaflet_1.default.Draw.Circle(map))[0];
    var circleMarkerHandler = react_1.useState(new leaflet_1.default.Draw.CircleMarker(map))[0];
    var handleDraw = function (type) {
        switch (type) {
            case context_1.DrawType.CIRCLE: {
                circleHandler.enable();
                break;
            }
            case context_1.DrawType.CIRCLE_MARKER: {
                circleMarkerHandler.enable();
                break;
            }
            case context_1.DrawType.MARKER: {
                markerHandler.enable();
                break;
            }
            case context_1.DrawType.POLYGON: {
                polygonHandler.enable();
                break;
            }
            case context_1.DrawType.POLYLINE: {
                polylineHandler.enable();
                break;
            }
            case context_1.DrawType.RECTANGLE: {
                rectangleHandler.enable();
                break;
            }
        }
    };
    react_1.useEffect(function () {
        if (props.onDrawCreated)
            map.on(leaflet_1.default.Draw.Event.CREATED, props.onDrawCreated);
        if (props.onDrawEdited)
            map.on(leaflet_1.default.Draw.Event.EDITED, props.onDrawEdited);
        if (props.onDrawDeleted)
            map.on(leaflet_1.default.Draw.Event.DELETED, props.onDrawDeleted);
        if (props.onDrawStart)
            map.on(leaflet_1.default.Draw.Event.DRAWSTART, props.onDrawStart);
        if (props.onDrawStop)
            map.on(leaflet_1.default.Draw.Event.DRAWSTOP, props.onDrawStop);
        if (props.onDrawVertex)
            map.on(leaflet_1.default.Draw.Event.DRAWVERTEX, props.onDrawVertex);
        if (props.onEditStart)
            map.on(leaflet_1.default.Draw.Event.EDITSTART, props.onEditStart);
        if (props.onEditMove)
            map.on(leaflet_1.default.Draw.Event.EDITMOVE, props.onEditMove);
        if (props.onEditResize)
            map.on(leaflet_1.default.Draw.Event.EDITRESIZE, props.onEditResize);
        if (props.onEditVertex)
            map.on(leaflet_1.default.Draw.Event.EDITVERTEX, props.onEditVertex);
        if (props.onEditStop)
            map.on(leaflet_1.default.Draw.Event.EDITSTOP, props.onEditStop);
        if (props.onDeleteStart)
            map.on(leaflet_1.default.Draw.Event.DELETESTART, props.onDeleteStart);
        if (props.onDeleteStop)
            map.on(leaflet_1.default.Draw.Event.DELETESTOP, props.onDeleteStop);
        if (props.onToolbarOpened)
            map.on(leaflet_1.default.Draw.Event.TOOLBAROPENED, props.onToolbarOpened);
        if (props.onToolbarClosed)
            map.on(leaflet_1.default.Draw.Event.TOOLBARCLOSED, props.onToolbarClosed);
        if (props.onMarkerContext)
            map.on(leaflet_1.default.Draw.Event.MARKERCONTEXT, props.onMarkerContext);
    }, [
        map,
        props.onDrawCreated,
        props.onDrawEdited,
        props.onDrawDeleted,
        props.onDrawStart,
        props.onDrawStop,
        props.onDrawVertex,
        props.onEditStart,
        props.onEditMove,
        props.onEditResize,
        props.onEditVertex,
        props.onEditStop,
        props.onDeleteStart,
        props.onDeleteStop,
        props.onToolbarOpened,
        props.onToolbarClosed,
        props.onMarkerContext,
    ]);
    return react_1.default.createElement(context_1.DrawProvider, { value: handleDraw }, props.children);
};
exports.LeafletDrawProvider = LeafletDrawProvider;
